From: Adrian Bunk <bunk@debian.org>
Date: Sun, 17 Jul 2022 03:24:18 +0300
Subject: Fix unaligned access in get_unigram_frequency()

In Debian the testsuite of fcitx5-zhuyin failed on 32-bit ARM
runnning on 64-bit hardware:
https://buildd.debian.org/status/fetch.php?pkg=fcitx5-zhuyin&arch=armhf&ver=5.0.8-1&stamp=1657997016&raw=0

The problem was the unaligned access, memcpy() the data instead.

Bug-Debian: https://bugs.debian.org/1015171
Forwarded: https://github.com/libpinyin/libpinyin/pull/152
---
 src/storage/phrase_index.h | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/src/storage/phrase_index.h b/src/storage/phrase_index.h
index 83dfb51..03e0483 100644
--- a/src/storage/phrase_index.h
+++ b/src/storage/phrase_index.h
@@ -122,7 +122,9 @@ public:
      */
     guint32 get_unigram_frequency(){
         char * buf_begin = (char *)m_chunk.begin();
-        return (*(guint32 *)(buf_begin + sizeof(guint8) + sizeof(guint8)));
+        guint32 retval;
+        memcpy(&retval, buf_begin + sizeof(guint8) + sizeof(guint8), sizeof(guint32));
+        return retval;
     }
 
     /**
